#pragma once

#include "v3.h"

class FrameBuffer;

class PPC {
public:
  V3 a, b, c, C;
  int w, h;
  PPC(float hfov, int w, int h);
  bool Project(V3 P, V3 &PP);
  V3 UnProject(V3 PP);
  void PositionAndOrient(V3 newC, V3 lap, V3 vpv);
  float GetF();
  V3 GetVD();
  V3 GetPointOnImagePlane(float uf, float vf);
  V3 GetPointOnFocalPlane(float uf, float vf, float f);
  void RenderWireframe(PPC *ppc, FrameBuffer *fb, float f,
    unsigned int color);
  void SetByInterpolation(PPC* ppc0, PPC* ppc1, float frac);
  void SetIntrinsicsHW(float nearz, float farz);
  void SetExtrinsicsHW();
};